t / test-lib.shon commit Add directory pattern matching to attributes (94bc671)
   1#!/bin/sh
   2#
   3# Copyright (c) 2005 Junio C Hamano
   4#
   5# This program is free software: you can redistribute it and/or modify
   6# it under the terms of the GNU General Public License as published by
   7# the Free Software Foundation, either version 2 of the License, or
   8# (at your option) any later version.
   9#
  10# This program is distributed in the hope that it will be useful,
  11# but WITHOUT ANY WARRANTY; without even the implied warranty of
  12# MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
  13# GNU General Public License for more details.
  14#
  15# You should have received a copy of the GNU General Public License
  16# along with this program.  If not, see http://www.gnu.org/licenses/ .
  17
  18# Keep the original TERM for say_color
  19ORIGINAL_TERM=$TERM
  20
  21# Test the binaries we have just built.  The tests are kept in
  22# t/ subdirectory and are run in 'trash directory' subdirectory.
  23if test -z "$TEST_DIRECTORY"
  24then
  25        # We allow tests to override this, in case they want to run tests
  26        # outside of t/, e.g. for running tests on the test library
  27        # itself.
  28        TEST_DIRECTORY=$(pwd)
  29fi
  30if test -z "$TEST_OUTPUT_DIRECTORY"
  31then
  32        # Similarly, override this to store the test-results subdir
  33        # elsewhere
  34        TEST_OUTPUT_DIRECTORY=$TEST_DIRECTORY
  35fi
  36GIT_BUILD_DIR="$TEST_DIRECTORY"/..
  37
  38################################################################
  39# It appears that people try to run tests without building...
  40"$GIT_BUILD_DIR/git" >/dev/null
  41if test $? != 1
  42then
  43        echo >&2 'error: you do not seem to have built git yet.'
  44        exit 1
  45fi
  46
  47. "$GIT_BUILD_DIR"/GIT-BUILD-OPTIONS
  48export PERL_PATH SHELL_PATH
  49
  50# if --tee was passed, write the output not only to the terminal, but
  51# additionally to the file test-results/$BASENAME.out, too.
  52case "$GIT_TEST_TEE_STARTED, $* " in
  53done,*)
  54        # do not redirect again
  55        ;;
  56*' --tee '*|*' --va'*)
  57        mkdir -p test-results
  58        BASE=test-results/$(basename "$0" .sh)
  59        (GIT_TEST_TEE_STARTED=done ${SHELL_PATH} "$0" "$@" 2>&1;
  60         echo $? > $BASE.exit) | tee $BASE.out
  61        test "$(cat $BASE.exit)" = 0
  62        exit
  63        ;;
  64esac
  65
  66# For repeatability, reset the environment to known value.
  67LANG=C
  68LC_ALL=C
  69PAGER=cat
  70TZ=UTC
  71TERM=dumb
  72export LANG LC_ALL PAGER TERM TZ
  73EDITOR=:
  74# A call to "unset" with no arguments causes at least Solaris 10
  75# /usr/xpg4/bin/sh and /bin/ksh to bail out.  So keep the unsets
  76# deriving from the command substitution clustered with the other
  77# ones.
  78unset VISUAL EMAIL LANGUAGE COLUMNS $("$PERL_PATH" -e '
  79        my @env = keys %ENV;
  80        my $ok = join("|", qw(
  81                TRACE
  82                DEBUG
  83                USE_LOOKUP
  84                TEST
  85                .*_TEST
  86                PROVE
  87                VALGRIND
  88                PERF_AGGREGATING_LATER
  89        ));
  90        my @vars = grep(/^GIT_/ && !/^GIT_($ok)/o, @env);
  91        print join("\n", @vars);
  92')
  93unset XDG_CONFIG_HOME
  94GIT_AUTHOR_EMAIL=author@example.com
  95GIT_AUTHOR_NAME='A U Thor'
  96GIT_COMMITTER_EMAIL=committer@example.com
  97GIT_COMMITTER_NAME='C O Mitter'
  98GIT_MERGE_VERBOSITY=5
  99GIT_MERGE_AUTOEDIT=no
 100export GIT_MERGE_VERBOSITY GIT_MERGE_AUTOEDIT
 101export GIT_AUTHOR_EMAIL GIT_AUTHOR_NAME
 102export GIT_COMMITTER_EMAIL GIT_COMMITTER_NAME
 103export EDITOR
 104
 105# Add libc MALLOC and MALLOC_PERTURB test
 106# only if we are not executing the test with valgrind
 107if expr " $GIT_TEST_OPTS " : ".* --valgrind " >/dev/null ||
 108   test -n "$TEST_NO_MALLOC_CHECK"
 109then
 110        setup_malloc_check () {
 111                : nothing
 112        }
 113        teardown_malloc_check () {
 114                : nothing
 115        }
 116else
 117        setup_malloc_check () {
 118                MALLOC_CHECK_=3 MALLOC_PERTURB_=165
 119                export MALLOC_CHECK_ MALLOC_PERTURB_
 120        }
 121        teardown_malloc_check () {
 122                unset MALLOC_CHECK_ MALLOC_PERTURB_
 123        }
 124fi
 125
 126# Protect ourselves from common misconfiguration to export
 127# CDPATH into the environment
 128unset CDPATH
 129
 130unset GREP_OPTIONS
 131
 132case $(echo $GIT_TRACE |tr "[A-Z]" "[a-z]") in
 1331|2|true)
 134        echo "* warning: Some tests will not work if GIT_TRACE" \
 135                "is set as to trace on STDERR ! *"
 136        echo "* warning: Please set GIT_TRACE to something" \
 137                "other than 1, 2 or true ! *"
 138        ;;
 139esac
 140
 141# Convenience
 142#
 143# A regexp to match 5 and 40 hexdigits
 144_x05='[0-9a-f][0-9a-f][0-9a-f][0-9a-f][0-9a-f]'
 145_x40="$_x05$_x05$_x05$_x05$_x05$_x05$_x05$_x05"
 146
 147# Zero SHA-1
 148_z40=0000000000000000000000000000000000000000
 149
 150# Line feed
 151LF='
 152'
 153
 154export _x05 _x40 _z40 LF
 155
 156# Each test should start with something like this, after copyright notices:
 157#
 158# test_description='Description of this test...
 159# This test checks if command xyzzy does the right thing...
 160# '
 161# . ./test-lib.sh
 162[ "x$ORIGINAL_TERM" != "xdumb" ] && (
 163                TERM=$ORIGINAL_TERM &&
 164                export TERM &&
 165                [ -t 1 ] &&
 166                tput bold >/dev/null 2>&1 &&
 167                tput setaf 1 >/dev/null 2>&1 &&
 168                tput sgr0 >/dev/null 2>&1
 169        ) &&
 170        color=t
 171
 172while test "$#" -ne 0
 173do
 174        case "$1" in
 175        -d|--d|--de|--deb|--debu|--debug)
 176                debug=t; shift ;;
 177        -i|--i|--im|--imm|--imme|--immed|--immedi|--immedia|--immediat|--immediate)
 178                immediate=t; shift ;;
 179        -l|--l|--lo|--lon|--long|--long-|--long-t|--long-te|--long-tes|--long-test|--long-tests)
 180                GIT_TEST_LONG=t; export GIT_TEST_LONG; shift ;;
 181        -h|--h|--he|--hel|--help)
 182                help=t; shift ;;
 183        -v|--v|--ve|--ver|--verb|--verbo|--verbos|--verbose)
 184                verbose=t; shift ;;
 185        -q|--q|--qu|--qui|--quie|--quiet)
 186                # Ignore --quiet under a TAP::Harness. Saying how many tests
 187                # passed without the ok/not ok details is always an error.
 188                test -z "$HARNESS_ACTIVE" && quiet=t; shift ;;
 189        --with-dashes)
 190                with_dashes=t; shift ;;
 191        --no-color)
 192                color=; shift ;;
 193        --va|--val|--valg|--valgr|--valgri|--valgrin|--valgrind)
 194                valgrind=t; verbose=t; shift ;;
 195        --tee)
 196                shift ;; # was handled already
 197        --root=*)
 198                root=$(expr "z$1" : 'z[^=]*=\(.*\)')
 199                shift ;;
 200        *)
 201                echo "error: unknown test option '$1'" >&2; exit 1 ;;
 202        esac
 203done
 204
 205if test -n "$color"
 206then
 207        say_color () {
 208                (
 209                TERM=$ORIGINAL_TERM
 210                export TERM
 211                case "$1" in
 212                error)
 213                        tput bold; tput setaf 1;; # bold red
 214                skip)
 215                        tput bold; tput setaf 2;; # bold green
 216                pass)
 217                        tput setaf 2;;            # green
 218                info)
 219                        tput setaf 3;;            # brown
 220                *)
 221                        test -n "$quiet" && return;;
 222                esac
 223                shift
 224                printf "%s" "$*"
 225                tput sgr0
 226                echo
 227                )
 228        }
 229else
 230        say_color() {
 231                test -z "$1" && test -n "$quiet" && return
 232                shift
 233                printf "%s\n" "$*"
 234        }
 235fi
 236
 237error () {
 238        say_color error "error: $*"
 239        GIT_EXIT_OK=t
 240        exit 1
 241}
 242
 243say () {
 244        say_color info "$*"
 245}
 246
 247test "${test_description}" != "" ||
 248error "Test script did not set test_description."
 249
 250if test "$help" = "t"
 251then
 252        echo "$test_description"
 253        exit 0
 254fi
 255
 256exec 5>&1
 257exec 6<&0
 258if test "$verbose" = "t"
 259then
 260        exec 4>&2 3>&1
 261else
 262        exec 4>/dev/null 3>/dev/null
 263fi
 264
 265test_failure=0
 266test_count=0
 267test_fixed=0
 268test_broken=0
 269test_success=0
 270
 271test_external_has_tap=0
 272
 273die () {
 274        code=$?
 275        if test -n "$GIT_EXIT_OK"
 276        then
 277                exit $code
 278        else
 279                echo >&5 "FATAL: Unexpected exit with code $code"
 280                exit 1
 281        fi
 282}
 283
 284GIT_EXIT_OK=
 285trap 'die' EXIT
 286
 287# The user-facing functions are loaded from a separate file so that
 288# test_perf subshells can have them too
 289. "$TEST_DIRECTORY/test-lib-functions.sh"
 290
 291# You are not expected to call test_ok_ and test_failure_ directly, use
 292# the text_expect_* functions instead.
 293
 294test_ok_ () {
 295        test_success=$(($test_success + 1))
 296        say_color "" "ok $test_count - $@"
 297}
 298
 299test_failure_ () {
 300        test_failure=$(($test_failure + 1))
 301        say_color error "not ok - $test_count $1"
 302        shift
 303        echo "$@" | sed -e 's/^/#       /'
 304        test "$immediate" = "" || { GIT_EXIT_OK=t; exit 1; }
 305}
 306
 307test_known_broken_ok_ () {
 308        test_fixed=$(($test_fixed+1))
 309        say_color "" "ok $test_count - $@ # TODO known breakage"
 310}
 311
 312test_known_broken_failure_ () {
 313        test_broken=$(($test_broken+1))
 314        say_color skip "not ok $test_count - $@ # TODO known breakage"
 315}
 316
 317test_debug () {
 318        test "$debug" = "" || eval "$1"
 319}
 320
 321test_eval_ () {
 322        # This is a separate function because some tests use
 323        # "return" to end a test_expect_success block early.
 324        eval </dev/null >&3 2>&4 "$*"
 325}
 326
 327test_run_ () {
 328        test_cleanup=:
 329        expecting_failure=$2
 330        test_eval_ "$1"
 331        eval_ret=$?
 332
 333        if test -z "$immediate" || test $eval_ret = 0 || test -n "$expecting_failure"
 334        then
 335                setup_malloc_check
 336                test_eval_ "$test_cleanup"
 337                teardown_malloc_check
 338        fi
 339        if test "$verbose" = "t" && test -n "$HARNESS_ACTIVE"
 340        then
 341                echo ""
 342        fi
 343        return "$eval_ret"
 344}
 345
 346test_skip () {
 347        test_count=$(($test_count+1))
 348        to_skip=
 349        for skp in $GIT_SKIP_TESTS
 350        do
 351                case $this_test.$test_count in
 352                $skp)
 353                        to_skip=t
 354                        break
 355                esac
 356        done
 357        if test -z "$to_skip" && test -n "$test_prereq" &&
 358           ! test_have_prereq "$test_prereq"
 359        then
 360                to_skip=t
 361        fi
 362        case "$to_skip" in
 363        t)
 364                of_prereq=
 365                if test "$missing_prereq" != "$test_prereq"
 366                then
 367                        of_prereq=" of $test_prereq"
 368                fi
 369
 370                say_color skip >&3 "skipping test: $@"
 371                say_color skip "ok $test_count # skip $1 (missing $missing_prereq${of_prereq})"
 372                : true
 373                ;;
 374        *)
 375                false
 376                ;;
 377        esac
 378}
 379
 380# stub; perf-lib overrides it
 381test_at_end_hook_ () {
 382        :
 383}
 384
 385test_done () {
 386        GIT_EXIT_OK=t
 387
 388        if test -z "$HARNESS_ACTIVE"
 389        then
 390                test_results_dir="$TEST_OUTPUT_DIRECTORY/test-results"
 391                mkdir -p "$test_results_dir"
 392                base=${0##*/}
 393                test_results_path="$test_results_dir/${base%.sh}-$$.counts"
 394
 395                cat >>"$test_results_path" <<-EOF
 396                total $test_count
 397                success $test_success
 398                fixed $test_fixed
 399                broken $test_broken
 400                failed $test_failure
 401
 402                EOF
 403        fi
 404
 405        if test "$test_fixed" != 0
 406        then
 407                say_color pass "# fixed $test_fixed known breakage(s)"
 408        fi
 409        if test "$test_broken" != 0
 410        then
 411                say_color error "# still have $test_broken known breakage(s)"
 412                msg="remaining $(($test_count-$test_broken)) test(s)"
 413        else
 414                msg="$test_count test(s)"
 415        fi
 416        case "$test_failure" in
 417        0)
 418                # Maybe print SKIP message
 419                if test -n "$skip_all" && test $test_count -gt 0
 420                then
 421                        error "Can't use skip_all after running some tests"
 422                fi
 423                [ -z "$skip_all" ] || skip_all=" # SKIP $skip_all"
 424
 425                if test $test_external_has_tap -eq 0
 426                then
 427                        if test $test_count -gt 0
 428                        then
 429                                say_color pass "# passed all $msg"
 430                        fi
 431                        say "1..$test_count$skip_all"
 432                fi
 433
 434                test -d "$remove_trash" &&
 435                cd "$(dirname "$remove_trash")" &&
 436                rm -rf "$(basename "$remove_trash")"
 437
 438                test_at_end_hook_
 439
 440                exit 0 ;;
 441
 442        *)
 443                if test $test_external_has_tap -eq 0
 444                then
 445                        say_color error "# failed $test_failure among $msg"
 446                        say "1..$test_count"
 447                fi
 448
 449                exit 1 ;;
 450
 451        esac
 452}
 453
 454if test -n "$valgrind"
 455then
 456        make_symlink () {
 457                test -h "$2" &&
 458                test "$1" = "$(readlink "$2")" || {
 459                        # be super paranoid
 460                        if mkdir "$2".lock
 461                        then
 462                                rm -f "$2" &&
 463                                ln -s "$1" "$2" &&
 464                                rm -r "$2".lock
 465                        else
 466                                while test -d "$2".lock
 467                                do
 468                                        say "Waiting for lock on $2."
 469                                        sleep 1
 470                                done
 471                        fi
 472                }
 473        }
 474
 475        make_valgrind_symlink () {
 476                # handle only executables, unless they are shell libraries that
 477                # need to be in the exec-path.  We will just use "#!" as a
 478                # guess for a shell-script, since we have no idea what the user
 479                # may have configured as the shell path.
 480                test -x "$1" ||
 481                test "#!" = "$(head -c 2 <"$1")" ||
 482                return;
 483
 484                base=$(basename "$1")
 485                symlink_target=$GIT_BUILD_DIR/$base
 486                # do not override scripts
 487                if test -x "$symlink_target" &&
 488                    test ! -d "$symlink_target" &&
 489                    test "#!" != "$(head -c 2 < "$symlink_target")"
 490                then
 491                        symlink_target=../valgrind.sh
 492                fi
 493                case "$base" in
 494                *.sh|*.perl)
 495                        symlink_target=../unprocessed-script
 496                esac
 497                # create the link, or replace it if it is out of date
 498                make_symlink "$symlink_target" "$GIT_VALGRIND/bin/$base" || exit
 499        }
 500
 501        # override all git executables in TEST_DIRECTORY/..
 502        GIT_VALGRIND=$TEST_DIRECTORY/valgrind
 503        mkdir -p "$GIT_VALGRIND"/bin
 504        for file in $GIT_BUILD_DIR/git* $GIT_BUILD_DIR/test-*
 505        do
 506                make_valgrind_symlink $file
 507        done
 508        # special-case the mergetools loadables
 509        make_symlink "$GIT_BUILD_DIR"/mergetools "$GIT_VALGRIND/bin/mergetools"
 510        OLDIFS=$IFS
 511        IFS=:
 512        for path in $PATH
 513        do
 514                ls "$path"/git-* 2> /dev/null |
 515                while read file
 516                do
 517                        make_valgrind_symlink "$file"
 518                done
 519        done
 520        IFS=$OLDIFS
 521        PATH=$GIT_VALGRIND/bin:$PATH
 522        GIT_EXEC_PATH=$GIT_VALGRIND/bin
 523        export GIT_VALGRIND
 524elif test -n "$GIT_TEST_INSTALLED"
 525then
 526        GIT_EXEC_PATH=$($GIT_TEST_INSTALLED/git --exec-path)  ||
 527        error "Cannot run git from $GIT_TEST_INSTALLED."
 528        PATH=$GIT_TEST_INSTALLED:$GIT_BUILD_DIR:$PATH
 529        GIT_EXEC_PATH=${GIT_TEST_EXEC_PATH:-$GIT_EXEC_PATH}
 530else # normal case, use ../bin-wrappers only unless $with_dashes:
 531        git_bin_dir="$GIT_BUILD_DIR/bin-wrappers"
 532        if ! test -x "$git_bin_dir/git"
 533        then
 534                if test -z "$with_dashes"
 535                then
 536                        say "$git_bin_dir/git is not executable; using GIT_EXEC_PATH"
 537                fi
 538                with_dashes=t
 539        fi
 540        PATH="$git_bin_dir:$PATH"
 541        GIT_EXEC_PATH=$GIT_BUILD_DIR
 542        if test -n "$with_dashes"
 543        then
 544                PATH="$GIT_BUILD_DIR:$PATH"
 545        fi
 546fi
 547GIT_TEMPLATE_DIR="$GIT_BUILD_DIR"/templates/blt
 548unset GIT_CONFIG
 549GIT_CONFIG_NOSYSTEM=1
 550GIT_ATTR_NOSYSTEM=1
 551export PATH GIT_EXEC_PATH GIT_TEMPLATE_DIR GIT_CONFIG_NOSYSTEM GIT_ATTR_NOSYSTEM
 552
 553if test -z "$GIT_TEST_CMP"
 554then
 555        if test -n "$GIT_TEST_CMP_USE_COPIED_CONTEXT"
 556        then
 557                GIT_TEST_CMP="$DIFF -c"
 558        else
 559                GIT_TEST_CMP="$DIFF -u"
 560        fi
 561fi
 562
 563GITPERLLIB="$GIT_BUILD_DIR"/perl/blib/lib:"$GIT_BUILD_DIR"/perl/blib/arch/auto/Git
 564export GITPERLLIB
 565test -d "$GIT_BUILD_DIR"/templates/blt || {
 566        error "You haven't built things yet, have you?"
 567}
 568
 569if test -z "$GIT_TEST_INSTALLED" && test -z "$NO_PYTHON"
 570then
 571        GITPYTHONLIB="$GIT_BUILD_DIR/git_remote_helpers/build/lib"
 572        export GITPYTHONLIB
 573        test -d "$GIT_BUILD_DIR"/git_remote_helpers/build || {
 574                error "You haven't built git_remote_helpers yet, have you?"
 575        }
 576fi
 577
 578if ! test -x "$GIT_BUILD_DIR"/test-chmtime
 579then
 580        echo >&2 'You need to build test-chmtime:'
 581        echo >&2 'Run "make test-chmtime" in the source (toplevel) directory'
 582        exit 1
 583fi
 584
 585# Test repository
 586test="trash directory.$(basename "$0" .sh)"
 587test -n "$root" && test="$root/$test"
 588case "$test" in
 589/*) TRASH_DIRECTORY="$test" ;;
 590 *) TRASH_DIRECTORY="$TEST_OUTPUT_DIRECTORY/$test" ;;
 591esac
 592test ! -z "$debug" || remove_trash=$TRASH_DIRECTORY
 593rm -fr "$test" || {
 594        GIT_EXIT_OK=t
 595        echo >&5 "FATAL: Cannot prepare test area"
 596        exit 1
 597}
 598
 599HOME="$TRASH_DIRECTORY"
 600export HOME
 601
 602if test -z "$TEST_NO_CREATE_REPO"
 603then
 604        test_create_repo "$test"
 605else
 606        mkdir -p "$test"
 607fi
 608# Use -P to resolve symlinks in our working directory so that the cwd
 609# in subprocesses like git equals our $PWD (for pathname comparisons).
 610cd -P "$test" || exit 1
 611
 612this_test=${0##*/}
 613this_test=${this_test%%-*}
 614for skp in $GIT_SKIP_TESTS
 615do
 616        case "$this_test" in
 617        $skp)
 618                say_color skip >&3 "skipping test $this_test altogether"
 619                skip_all="skip all tests in $this_test"
 620                test_done
 621        esac
 622done
 623
 624# Provide an implementation of the 'yes' utility
 625yes () {
 626        if test $# = 0
 627        then
 628                y=y
 629        else
 630                y="$*"
 631        fi
 632
 633        while echo "$y"
 634        do
 635                :
 636        done
 637}
 638
 639# Fix some commands on Windows
 640case $(uname -s) in
 641*MINGW*)
 642        # Windows has its own (incompatible) sort and find
 643        sort () {
 644                /usr/bin/sort "$@"
 645        }
 646        find () {
 647                /usr/bin/find "$@"
 648        }
 649        sum () {
 650                md5sum "$@"
 651        }
 652        # git sees Windows-style pwd
 653        pwd () {
 654                builtin pwd -W
 655        }
 656        # no POSIX permissions
 657        # backslashes in pathspec are converted to '/'
 658        # exec does not inherit the PID
 659        test_set_prereq MINGW
 660        test_set_prereq SED_STRIPS_CR
 661        ;;
 662*CYGWIN*)
 663        test_set_prereq POSIXPERM
 664        test_set_prereq EXECKEEPSPID
 665        test_set_prereq NOT_MINGW
 666        test_set_prereq SED_STRIPS_CR
 667        ;;
 668*)
 669        test_set_prereq POSIXPERM
 670        test_set_prereq BSLASHPSPEC
 671        test_set_prereq EXECKEEPSPID
 672        test_set_prereq NOT_MINGW
 673        ;;
 674esac
 675
 676( COLUMNS=1 && test $COLUMNS = 1 ) && test_set_prereq COLUMNS_CAN_BE_1
 677test -z "$NO_PERL" && test_set_prereq PERL
 678test -z "$NO_PYTHON" && test_set_prereq PYTHON
 679test -n "$USE_LIBPCRE" && test_set_prereq LIBPCRE
 680test -z "$NO_GETTEXT" && test_set_prereq GETTEXT
 681
 682# Can we rely on git's output in the C locale?
 683if test -n "$GETTEXT_POISON"
 684then
 685        GIT_GETTEXT_POISON=YesPlease
 686        export GIT_GETTEXT_POISON
 687        test_set_prereq GETTEXT_POISON
 688else
 689        test_set_prereq C_LOCALE_OUTPUT
 690fi
 691
 692# Use this instead of test_cmp to compare files that contain expected and
 693# actual output from git commands that can be translated.  When running
 694# under GETTEXT_POISON this pretends that the command produced expected
 695# results.
 696test_i18ncmp () {
 697        test -n "$GETTEXT_POISON" || test_cmp "$@"
 698}
 699
 700# Use this instead of "grep expected-string actual" to see if the
 701# output from a git command that can be translated either contains an
 702# expected string, or does not contain an unwanted one.  When running
 703# under GETTEXT_POISON this pretends that the command produced expected
 704# results.
 705test_i18ngrep () {
 706        if test -n "$GETTEXT_POISON"
 707        then
 708            : # pretend success
 709        elif test "x!" = "x$1"
 710        then
 711                shift
 712                ! grep "$@"
 713        else
 714                grep "$@"
 715        fi
 716}
 717
 718test_lazy_prereq SYMLINKS '
 719        # test whether the filesystem supports symbolic links
 720        ln -s x y && test -h y
 721'
 722
 723test_lazy_prereq CASE_INSENSITIVE_FS '
 724        echo good >CamelCase &&
 725        echo bad >camelcase &&
 726        test "$(cat CamelCase)" != good
 727'
 728
 729test_lazy_prereq UTF8_NFD_TO_NFC '
 730        # check whether FS converts nfd unicode to nfc
 731        auml=$(printf "\303\244")
 732        aumlcdiar=$(printf "\141\314\210")
 733        >"$auml" &&
 734        case "$(echo *)" in
 735        "$aumlcdiar")
 736                true ;;
 737        *)
 738                false ;;
 739        esac
 740'
 741
 742test_lazy_prereq AUTOIDENT '
 743        sane_unset GIT_AUTHOR_NAME &&
 744        sane_unset GIT_AUTHOR_EMAIL &&
 745        git var GIT_AUTHOR_IDENT
 746'
 747
 748# When the tests are run as root, permission tests will report that
 749# things are writable when they shouldn't be.
 750test -w / || test_set_prereq SANITY